function [idx_all,d_all,hit_rate,data_test_reconstruct]=classify_images(data_test,data_train_pca,no_train,no_total,avg_img_allpers,V_pca,d_type,fisher_train,fisher_basis,flag_fisher); 
% Compute classification performances

% Setup parameters
no_test=no_total-no_train;
idx_all=[];
d_all=[];
hit_rate=0;
data_test_reconstruct=[];

for i=1:size(data_test,2)
    d=data_test(:,i);
    d_center=d-avg_img_allpers;
    z=V_pca'*d_center;
    if flag_fisher == 1
        z_fisher=fisher_basis'*z;
    else
        z_fisher=[];
    end
    d_reconstruct=V_pca*V_pca'*d_center;
    data_test_reconstruct=[data_test_reconstruct d_reconstruct];
    if strcmp(d_type,'euclidean')
        dif=dist(z',data_train_pca);
    elseif strcmp(d_type,'fisher') && flag_fisher == 1
        dif=dist(z_fisher',fisher_train);
    else
        dif=[]; d_all=[]; idx_all=[]; break
    end
    [d_min,I_min]=min(dif);
    d_all=[d_all d_min];
    idx_all=[idx_all I_min];
end
    
for k=1:size(data_test,2)
    idx_min=idx_all(k);
    idx=fix(k/no_test);
    rest=rem(k,no_test);
    if rest ~= 0
        idx_1=no_train*idx+1;
        idx_2=no_train*idx+no_train;
    else
        idx_1=no_train*idx-no_train+1;
        idx_2=no_train*idx;
    end
    if idx_min >= idx_1 && idx_min <= idx_2
        hit_rate=hit_rate+1;
    else
    end
end
hit_rate=hit_rate/size(data_test,2);
