function [P,flag_err,p_norm]=process(proc,input,param,h);
% Functie MATLAB pentru preprocesarea datelor de intrare
% Semnificatia parametrilor:	proc - variabila STRING care desemneaza tipul procesarii (sample,permute,norm);
%				input - matrice de date asupra careia actioneaza procesarea;
%				param - vector de parametri care caracterizeaza procesarea;
%               flag_err

flag_err=0;

if nargin >= 4
	set(h,'enable','on');
else
	if	strcmp(proc,'sample')
		for i=1:ceil(size(input,2)/param(1))
			P(:,i)=input(:,param*(i-1)+1);
		end
	elseif  strcmp(proc,'permute')
	index=1:size(input,2);
		for n=1:size(input,2)
			i=ceil(size(input,2)*rand);
			j=ceil(size(input,2)*rand);
			ind=index(j);
			index(j)=index(i);
			index(i)=ind;
		end
		for k=1:size(input,2)
			P(:,k)=input(:,index(k));
		end
	elseif	strcmp(proc,'norm')
	    p_norm=[];
        low=param(1);high=param(2);
		if low>=high
			disp('Error: maximum value should be greater than the minimum value')
        else
			for i=1:size(input,1)
				if max(input(i,:)) ~= min(input(i,:))
                    a_norm=(high-low)/(max(input(i,:))-min(input(i,:)));
                    b_norm=(low*max(input(i,:))-high*min(input(i,:)))/(max(input(i,:))-min(input(i,:)));
                else
                    a_norm=1;
                    b_norm=0;
                end
				a_denorm=1/a_norm;
				b_denorm=(high*min(input(i,:))-low*max(input(i,:)))/(high-low);			
				p_norm=[p_norm;a_denorm b_denorm];
                for j=1:size(input,2)
					P(i,j)=a_norm*input(i,j)+b_norm;
				end
			end
		end
	%p_norm=[a_denorm b_denorm];
    % ========================
    elseif	strcmp(proc,'norm_global')
	    low=param(1);high=param(2);
		if low>=high
			flag_err=1;
            disp('Error: maximum value should be greater than the minimum value')
        elseif  max(max(input)) == min(min(input))
            max(max(input))
            min(min(input))
            flag_err=1;
        elseif low < high & max(max(input)) ~= min(min(input))
				a_norm=(high-low)/(max(max(input))-min(min(input)));
				b_norm=(low*max(max(input))-high*min(min(input)))/(max(max(input))-min(min(input)));		
				a_denorm=1/a_norm;
				b_denorm=(high*min(min(input))-low*max(max(input)))/(high-low);			
				for j=1:size(input,2)
					P(:,j)=a_norm*input(:,j)+b_norm;
				end
        end
	    p_norm=[a_norm b_norm a_denorm b_denorm];
    % ========================
    elseif	strcmp(proc,'denorm')
		for j=1:size(input,2)
			P(j)=param(1)*input(j)+param(2);
		end
	p_norm=[min(P) max(P)];
	elseif	strcmp(proc,'transp')
		P=input';
	elseif	strcmp(proc,'predict')
		mem_depth=param(1);
%		shift=param(2);	 	
		if size(input,1) == 1 
			for j=1:length(input)-mem_depth+1
				P(:,j)=input(j:j+mem_depth-1)';
			end
		elseif size(input,2) == 1
			for j=1:length(input)-mem_depth+1
				P(:,j)=input(j:j+mem_depth-1);
			end
		else	
			disp('Error: Data should be a vector')		 		
		end
	else
	end
end
